# Lamp class

import math

import pygame
from pygame.locals import *

import tools, parameters

class Lamp(pygame.sprite.Sprite):
    """Lamp class"""

    state = 'on_shelf'

    def __init__(self, pos):
        init_rect = Rect(pos[0], pos[1], 10,10)

        color = (255,0,0)
        
        pygame.sprite.Sprite.__init__(self)

        self.image, self.rect = tools.get_solid(init_rect.size, color)

        self.rect.topleft = init_rect.topleft

        # Dead end... this, found another way
    def chk_prox(self, sprite):

        # check if lamp is in range of sensors
        hyp = tools.mag(self.rect.center,sprite.rect.center) 
        if hyp < parameters.SENSOR_RANGE:
            print 'in range'

            # check if lamp is in 'feild of vision for sensors'
            unit_vec_veh = (math.cos(math.radians(sprite.get_direction())),\
                                math.radians(math.sin(sprite.get_direction())))

            vec_lamp = (sprite.rect.centerx - self.rect.centerx,\
                        sprite.rect.centery - self.rect.centery)

            print vec_lamp
            #norm = tools.norm(vec_lamp)
            
            #unit_vec_lamp = (vec_lamp[0]/norm, vec_lamp[1]/norm)
            
            diff = (int(math.degrees(math.acos(tools.dot(unit_vec_veh, vec_lamp)/ \
                            (tools.norm(unit_vec_veh)*tools.norm(vec_lamp))))))
            print diff
            #if diff < 90:
            #    print 'right_sensor', diff
            #else:
            #    print 'left_sensor', diff
    
    def check_clicked(self, pos):
        if self.rect.collidepoint(pos):
            self.state = 'picked_up'
            return 1
        else:
            return 0
            
    def update(self):
        if self.state == 'picked_up':
            pos = pygame.mouse.get_pos()
            self.rect.center = pos
            
